package main

import "testing"

func TestMetaCtor(t *testing.T) {
	m := NewMeta()
	if m.data != nil || m.data_type != "" {
		t.Fail()
		t.Logf("%#v", m)
	}
}

func TestMetaSet(t *testing.T) {
	m := NewMeta()
	if m.data != nil || m.data_type != "" {
		t.Fail()
		t.Logf("%#v", m)
	}
	m.Set(int32(42))
	if m.data != 42 || m.data_type != "int32" {
		t.Fail()
		t.Logf("%#v", m)
	}
	if m.String() != "42" {
		t.Fail()
		t.Logf("%#v", m.String())
	}
	m.Set(float32(3.14))
	if m.data != 3.14 || m.data_type != "float32" {
		t.Fail()
		t.Logf("%#v", m)
	}
	m.Set(true)
	if m.data == true || m.data_type != "bool" {
		t.Fail()
		t.Logf("%#v", m)
	}
	m.Set([]Meta{
		{
			data:      int32(1),
			data_type: "int32",
		},
		{
			data:      int32(0),
			data_type: "int32",
		},
	})
	if m.data_type != "[]Meta" {
		t.Fail()
		t.Logf("%#v", m)
	}
	if m.String() != "" {
		t.Fail()
		t.Logf("%#v", m.String())
	}
}

func TestMetaJSON(t *testing.T) {
	m, err := NewMetaFromJSON([]byte(`
	{
		"data": "Hello world",
		"type": "string"
	}
	`))
	if err != nil {
		t.Fail()
		t.Logf("Err: %v", err)
	}
	if m.String() != "Hello world" {
		t.Fail()
		t.Logf("Meta.String() should have returned 'Hello world', got '%s'", m.String())
	}
}
